<template>
    <v-chart ref="echart" :options="chart_options" autoresize></v-chart>
</template>

<script>
    export default {
        name: "UsersGrowth",
        props: {
            users_count: Number,
            previous_users_count: Number,
        },
        computed: {
            chart_data(){
                let abs_percent = Math.abs(this.activePercent);
                return [
                    {
                        value: abs_percent,
                        itemStyle: this.chartItemStyle
                    },
                    {
                        value: 100 - abs_percent ,
                        itemStyle: {
                            color: '#ebebeb'
                        }
                    }
                ];
            },
            activePercent(){
                if(0 === this.users_count && 0 === this.previous_users_count){
                    return 0;
                }else if(0 === this.users_count){
                    return -100;
                }else if(0 === this.previous_users_count){
                    return 100;
                }
                let diff = this.users_count - this.previous_users_count;
                return (diff / this.previous_users_count * 100).toFixed(0);
            },
            chartItemStyle(){
                if(this.activePercent >= 0){
                    return {
                        color: {
                            type: 'linear',
                            x: 0,
                            y: 1,
                            x2: 1,
                            y2: 0,
                            colorStops: [{
                                offset: 0, color: 'rgb(81, 185, 252)'
                            }, {
                                offset: 1, color: 'rgb(26, 121, 230)'
                            }],
                            global: false
                        }
                    };
                }else{
                    return {
                        color: {
                            type: 'linear',
                            x: 0,
                            y: 1,
                            x2: 1,
                            y2: 0,
                            colorStops: [{
                                offset: 0, color: 'rgb(255, 124, 109)' // color at 0% position
                            }, {
                                offset: 1, color: 'rgb(244, 48, 127)' // color at 100% position
                            }],
                            global: false
                        }
                    };
                }
            },
            clockwise(){
                return this.activePercent >= 0;
            }
        },
        watch: {
            chart_data(data){
                this.chart_options.series[0].data = data;
            },
            activePercent(percent){
                this.chart_options.graphic.elements[0].style.text = percent + '%';
            },
            chartItemStyle(style){
                this.chart_options.series[0].data[0].itemStyle = style;
            },
            clockwise(clockwise){
                this.chart_options.series[0].clockwise = clockwise;
            },
        },
        data(){
            return {
                chart_options: {
                    graphic: {
                        elements: [
                            {
                                type: 'text',
                                left: 'center',
                                top: 'middle',
                                z: 100,
                                style: {
                                    text: '50%',
                                    fill: '#c9c9c9',
                                    font: 'bold 27px "Geometria"'
                                }
                            }
                        ]
                    },
                    series: [
                        {
                            name: 'chart',
                            type: 'pie',
                            top: 0,
                            left: 0,
                            width: 112,
                            height: 112,
                            hoverOffset: 0,
                            startAngle: 90,
                            clockwise: true,
                            radius: ['80%', '100%'],
                            center: ['50%', '50%'],
                            label: {
                                show: false,
                            },
                            data: [
                                {
                                    value: this.activePercent || 50,
                                    itemStyle: this.chartItemStyle
                                },
                                {
                                    value: 100 - this.activePercent || 50,
                                    itemStyle: {
                                        color: '#ebebeb'
                                    }
                                }
                            ]
                        }
                    ],
                }
            }
        },
        mounted() {
            this.chart_options.series[0].data = this.chart_data;
            this.chart_options.graphic.elements[0].style.text = this.activePercent + '%';
            this.chart_options.series[0].data[0].itemStyle = this.chartItemStyle;
            this.chart_options.series[0].clockwise = this.clockwise;
        }
    }
</script>

<style scoped>
.echarts {
    width: 112px;
    height: 112px;
	margin: 0 auto;
}
</style>
